NX Open C++ Reference Guide
Public Types | Public Member Functions | List of all members
NXOpen::Features::SilhouetteFlangeBuilder Class Reference

Represents a NXOpen::Features::SilhouetteFlange builder
To create a new instance of this class, use NXOpen::Features::FeatureCollection::CreateSilhouetteFlangeBuilder
Default values. More...

Inheritance diagram for NXOpen::Features::SilhouetteFlangeBuilder:
NXOpen::Features::FeatureBuilder NXOpen::Builder NXOpen::TaggedObject NXOpen::GeometricUtilities::IComponentBuilder

Public Types

enum  OutputSurfaceOptions { OutputSurfaceOptionsBlendFlange, OutputSurfaceOptionsPipeOnly, OutputSurfaceOptionsFlangeOnly }
 Output surface options. More...
 
enum  ReferenceDirectionOptions { ReferenceDirectionOptionsFaceNormal, ReferenceDirectionOptionsVector, ReferenceDirectionOptionsNormalDraft, ReferenceDirectionOptionsVectorDraft }
 Reference direction options. More...
 
enum  Types { TypesBasic, TypesAbsoluteGap, TypesVisualGap }
 Silhouette flange creation types. More...
 

Public Member Functions

NXOpen::GeometricUtilities::LawBuilderAngleLaw ()
 Returns the angle law. More...
 
NXOpen::SectionBaseCurves ()
 Returns the base curves. More...
 
NXOpen::ScCollectorBaseFaces ()
 Returns the base faces. More...
 
int BaseFactor ()
 Returns the base pipe continuity factor. More...
 
NXOpen::GeometricUtilities::ContinuityBasePipeContinuity ()
 Returns the base pipe continuity. More...
 
bool CreateCurves ()
 Returns a value that indicates whether to create curves. More...
 
void CreatePipe ()
 Create the tube from the given inputs. More...
 
bool ExtendFlange ()
 Returns a value that indicates whether to extend flange until the boundary edges of the base faces. More...
 
int FlangeFactor ()
 Returns the flange pipe continuity factor. More...
 
NXOpen::GeometricUtilities::ContinuityFlangePipeContinuity ()
 Returns the flange pipe continuity
Created in NX6.0.0. More...
 
NXOpen::ExpressionGap ()
 Returns the gap
Created in NX6.0.0. More...
 
NXOpen::CurveGetCenterCurve ()
 Return the center curve. More...
 
bool GetIsDirectionFlipped ()
 A value indicating whether to flip the direction. More...
 
bool GetIsSideFlipped ()
 Returns a value indicating whether to flip the side. More...
 
NXOpen::CurveGetSilhouetteCurve ()
 Return the silhouette curve. More...
 
NXOpen::GeometricUtilities::LawBuilderLengthLaw ()
 Returns the length law. More...
 
bool MergeFacesIfPossible ()
 Returns a value that indicates whether to the merge faces if possible
Created in NX6.0.0. More...
 
NXOpen::Features::SilhouetteFlangeBuilder::OutputSurfaceOptions OutputSurfaceOption ()
 Returns the output surface option
Created in NX6.0.0. More...
 
NXOpen::Features::SelectFeatureParentFeature ()
 Returns the parent feature. More...
 
double PositionTolerance ()
 Returns the position tolerance
Created in NX6.0.0. More...
 
NXOpen::GeometricUtilities::LawBuilderRadiusLaw ()
 Returns the radius law. More...
 
NXOpen::Features::SilhouetteFlangeBuilder::ReferenceDirectionOptions ReferenceDirectionOption ()
 Returns the reference direction option
Created in NX6.0.0. More...
 
NXOpen::ScCollectorReferenceFaces ()
 Returns the reference faces. More...
 
NXOpen::DirectionReferenceVector ()
 Returns the reference vector
Created in NX6.0.0. More...
 
void SetBaseFactor (int baseFactor)
 Sets the base pipe continuity factor. More...
 
void SetCreateCurves (bool createCurves)
 Sets a value that indicates whether to create curves. More...
 
void SetExtendFlange (bool extendFlange)
 Sets a value that indicates whether to extend flange until the boundary edges of the base faces. More...
 
void SetFlangeFactor (int flangeFactor)
 Sets the flange pipe continuity factor. More...
 
void SetIsDirectionFlipped (bool flipDirection)
 Sets a flag indicating if the direction is flipped. More...
 
void SetIsSideFlipped (bool flipSide)
 Sets a value indicating whether to flip the side. More...
 
void SetMergeFacesIfPossible (bool mergeFacesIfPossible)
 Sets a value that indicates whether to the merge faces if possible
Created in NX6.0.0. More...
 
void SetOutputSurfaceOption (NXOpen::Features::SilhouetteFlangeBuilder::OutputSurfaceOptions outputSurfaceOption)
 Sets the output surface option
Created in NX6.0.0. More...
 
void SetPositionTolerance (double positionTolerance)
 Sets the position tolerance
Created in NX6.0.0. More...
 
void SetReferenceDirectionOption (NXOpen::Features::SilhouetteFlangeBuilder::ReferenceDirectionOptions referenceDirectionOption)
 Sets the reference direction option
Created in NX6.0.0. More...
 
void SetReferenceVector (NXOpen::Direction *referenceVctor)
 Sets the reference vector
Created in NX6.0.0. More...
 
void SetShowPipe (bool showPipe)
 Sets a value that indicates whether to show pipe
Created in NX6.0.0. More...
 
void SetTangentTolerance (double tangentTolerance)
 Sets the tangent tolerance
Created in NX6.0.0. More...
 
void SetTrimBaseFaces (bool trimBaseFaces)
 Sets a value that indicates whether to trim base faces
Created in NX6.0.0. More...
 
void SetType (NXOpen::Features::SilhouetteFlangeBuilder::Types type)
 Sets the type
Created in NX6.0.0. More...
 
bool ShowPipe ()
 Returns a value that indicates whether to show pipe
Created in NX6.0.0. More...
 
double TangentTolerance ()
 Returns the tangent tolerance
Created in NX6.0.0. More...
 
bool TrimBaseFaces ()
 Returns a value that indicates whether to trim base faces
Created in NX6.0.0. More...
 
NXOpen::Features::SilhouetteFlangeBuilder::Types Type ()
 Returns the type
Created in NX6.0.0. More...
 
void UpdateLawSpine ()
 Update the spine curve in length/angle/radius laws. More...
 
- Public Member Functions inherited from NXOpen::Features::FeatureBuilder
NXOpen::Features::FeatureCommitFeature ()
 Commits the feature parameters and creates the feature. More...
 
NXOpen::Features::FeatureGetFeature ()
 Returns the feature currently being edited by this builder. More...
 
void HideInternalParentFeatureAfterEdit (NXOpen::Features::Feature *parentFeature)
 Re-suppress an internal parent feature (a slave feature) after it has been edited. More...
 
bool ParentFeatureInternal ()
 Returns whether or not the latest timestamped parent feature of this feature should be made internal
Created in NX5.0.0. More...
 
bool PatchSolutionFlag ()
 Returns the patch solution flag
Created in NX8.0.1. More...
 
NXString PatchSurfaceFilename ()
 Returns the patch surface filename
Created in NX8.0.1. More...
 
void SetParentFeatureInternal (NXOpen::Features::Feature *parentFeature)
 Set the parent features which would be internal or slaves to the feature being created or commited
Created in NX6.0.0. More...
 
void SetParentFeatureInternal (bool isInternal)
 Sets whether or not the latest timestamped parent feature of this feature should be made internal
Created in NX5.0.0. More...
 
void SetPatchSolutionFlag (bool optionValue)
 Sets the patch solution flag
Created in NX8.0.1. More...
 
void SetPatchSurfaceFilename (const NXString &surfaceFilename)
 Sets the patch surface filename
Created in NX8.0.1. More...
 
void SetPatchSurfaceFilename (const char *surfaceFilename)
 Sets the patch surface filename
Created in NX8.0.1. More...
 
void SetSurroundingPatchSurfaceFilename (const NXString &surroundingSurfaceFilename)
 Sets the surrounding patch surface filename
Created in NX8.0.1. More...
 
void SetSurroundingPatchSurfaceFilename (const char *surroundingSurfaceFilename)
 Sets the surrounding patch surface filename
Created in NX8.0.1. More...
 
void ShowInternalParentFeatureForEdit (NXOpen::Features::Feature *parentFeature)
 Unsuppress an internal parent feature (a slave feature) so it can be edited. More...
 
NXString SurroundingPatchSurfaceFilename ()
 Returns the surrounding patch surface filename
Created in NX8.0.1. More...
 
void UnsetParentFeatureInternal (NXOpen::Features::Feature *parentFeature)
 Set the internal parent feature of the feature being edited to external
Created in NX6.0.0. More...
 
- Public Member Functions inherited from NXOpen::Builder
NXOpen::NXObjectCommit ()
 Commits any edits that have been applied to the builder. More...
 
void Destroy ()
 Deletes the builder, and cleans up any objects created by the builder. More...
 
std::vector< NXOpen::NXObject * > GetCommittedObjects ()
 For builders that create more than one object, this method returns the objects that are created by commit. More...
 
NXOpen::NXObjectGetObject ()
 Returns the object currently being edited by this builder. More...
 
void ShowResults ()
 Updates the model to reflect the result of an edit to the model for all builders that support showing results. More...
 
virtual bool Validate ()
 Validate whether the inputs to the component are sufficient for commit to be called. More...
 
- Public Member Functions inherited from NXOpen::TaggedObject
tag_t Tag () const
 Returns the tag of this object. More...
 

Detailed Description

Represents a NXOpen::Features::SilhouetteFlange builder
To create a new instance of this class, use NXOpen::Features::FeatureCollection::CreateSilhouetteFlangeBuilder
Default values.

Property Value

AngleLaw.Function

ft

AngleLaw.LawType

MultiTransition

AngleLaw.Parameter

t

BaseFactor

0

BasePipeContinuity.ContinuityType

G1

CreateCurves

0

ExtendFlange

1

FlangeFactor

0

FlangePipeContinuity.ContinuityType

G0

Gap.Value

5 (millimeters part), 0.2 (inches part)

LengthLaw.LawType

MultiTransition

MergeFacesIfPossible

0

RadiusLaw.LawType

MultiTransition

ReferenceDirectionOption

NormalDraft

ShowPipe

0

TrimBaseFaces

0

Type

Basic


Created in NX6.0.0.

Member Enumeration Documentation

Output surface options.

Enumerator
OutputSurfaceOptionsBlendFlange 

Output blend and flange surfaces.

OutputSurfaceOptionsPipeOnly 

Output pipe.

OutputSurfaceOptionsFlangeOnly 

Output flange surface.

Reference direction options.

Enumerator
ReferenceDirectionOptionsFaceNormal 

Create flange along face normal.

ReferenceDirectionOptionsVector 

Create flange along reference vector.

ReferenceDirectionOptionsNormalDraft 

Create flange along silhouette curve and face normal.

ReferenceDirectionOptionsVectorDraft 

Create flange along silhouette curve and reference vector.

Silhouette flange creation types.

Enumerator
TypesBasic 

Basic Silhouette Flange.

TypesAbsoluteGap 

Absolute gap Silhouette Flange.

TypesVisualGap 

Visual gap Silhouette Flange.

Member Function Documentation

NXOpen::GeometricUtilities::LawBuilder* NXOpen::Features::SilhouetteFlangeBuilder::AngleLaw ( )

Returns the angle law.

The only supported law type is GeometricUtilities::LawBuilder::TypeMultiTransition .
Created in NX6.0.0.

License requirements : None

NXOpen::Section* NXOpen::Features::SilhouetteFlangeBuilder::BaseCurves ( )

Returns the base curves.

Base curves must be G1 continuous.
Created in NX6.0.0.

License requirements : None

NXOpen::ScCollector* NXOpen::Features::SilhouetteFlangeBuilder::BaseFaces ( )

Returns the base faces.

The base faces could be from different sheet bodies, but they must be G1 continuous.
Created in NX6.0.0.

License requirements : None

int NXOpen::Features::SilhouetteFlangeBuilder::BaseFactor ( )

Returns the base pipe continuity factor.

It's used to determine what percentage of the arc will be trimmed away in order to build the transition surface between the base faces and the pipe.
Created in NX6.0.0.

License requirements : None

NXOpen::GeometricUtilities::Continuity* NXOpen::Features::SilhouetteFlangeBuilder::BasePipeContinuity ( )

Returns the base pipe continuity.


Created in NX6.0.0.

License requirements : None

bool NXOpen::Features::SilhouetteFlangeBuilder::CreateCurves ( )

Returns a value that indicates whether to create curves.

When this option is true, the center line curve of the pipe and silhouette flange curve at zero degrees will be output.
Created in NX6.0.0.

License requirements : None

void NXOpen::Features::SilhouetteFlangeBuilder::CreatePipe ( )

Create the tube from the given inputs.

The tube must be created before creating any flange surface.
Created in NX12.0.0.

License requirements : nx_freeform_2 ("advanced freeform modeling")

bool NXOpen::Features::SilhouetteFlangeBuilder::ExtendFlange ( )

Returns a value that indicates whether to extend flange until the boundary edges of the base faces.

This option will be enforced if Trim Base Faces option is true. The base faces cannot be trimmed if the pipe does not hit the boundary edges of base faces.
Created in NX6.0.0.

License requirements : None

int NXOpen::Features::SilhouetteFlangeBuilder::FlangeFactor ( )

Returns the flange pipe continuity factor.

It's used to determine what percentage of the arc will be trimmed away in order to build the transition surface between the pipe and flange surface.
Created in NX6.0.0.

License requirements : None

NXOpen::GeometricUtilities::Continuity* NXOpen::Features::SilhouetteFlangeBuilder::FlangePipeContinuity ( )

Returns the flange pipe continuity
Created in NX6.0.0.



License requirements : None

NXOpen::Expression* NXOpen::Features::SilhouetteFlangeBuilder::Gap ( )

Returns the gap
Created in NX6.0.0.



License requirements : None

NXOpen::Curve* NXOpen::Features::SilhouetteFlangeBuilder::GetCenterCurve ( )

Return the center curve.

Returns

Created in NX8.0.0.

License requirements : None
bool NXOpen::Features::SilhouetteFlangeBuilder::GetIsDirectionFlipped ( )

A value indicating whether to flip the direction.

If the direction is flipped, the pipe is placed to the opposite side of base faces and flange direction is flipped.

Returns

Created in NX6.0.0.

License requirements : None
bool NXOpen::Features::SilhouetteFlangeBuilder::GetIsSideFlipped ( )

Returns a value indicating whether to flip the side.

If the side is flipped, the pipe is placed to the other side of base curves for Basic Type and the other side of the pipe of the parent feature for Absolute/Visual Gap Type.

Returns

Created in NX6.0.0.

License requirements : None
NXOpen::Curve* NXOpen::Features::SilhouetteFlangeBuilder::GetSilhouetteCurve ( )

Return the silhouette curve.

Returns

Created in NX8.0.0.

License requirements : None
NXOpen::GeometricUtilities::LawBuilder* NXOpen::Features::SilhouetteFlangeBuilder::LengthLaw ( )

Returns the length law.

The only supported law type is GeometricUtilities::LawBuilder::TypeMultiTransition .
Created in NX6.0.0.

License requirements : None

bool NXOpen::Features::SilhouetteFlangeBuilder::MergeFacesIfPossible ( )

Returns a value that indicates whether to the merge faces if possible
Created in NX6.0.0.



License requirements : None

NXOpen::Features::SilhouetteFlangeBuilder::OutputSurfaceOptions NXOpen::Features::SilhouetteFlangeBuilder::OutputSurfaceOption ( )

Returns the output surface option
Created in NX6.0.0.



License requirements : None

NXOpen::Features::SelectFeature* NXOpen::Features::SilhouetteFlangeBuilder::ParentFeature ( )

Returns the parent feature.

Parent feature must be a Silhouette Flange feature. A NXOpen::Features::SilhouetteFlangeBuilder::TypesVisualGap silhouette flange and its parent Silhouette Flange feature should use parallel vectors as reference direction.
Created in NX6.0.0.

License requirements : None

double NXOpen::Features::SilhouetteFlangeBuilder::PositionTolerance ( )

Returns the position tolerance
Created in NX6.0.0.



License requirements : None

NXOpen::GeometricUtilities::LawBuilder* NXOpen::Features::SilhouetteFlangeBuilder::RadiusLaw ( )

Returns the radius law.

The only supported law type is GeometricUtilities::LawBuilder::TypeMultiTransition .
Created in NX6.0.0.

License requirements : None

NXOpen::Features::SilhouetteFlangeBuilder::ReferenceDirectionOptions NXOpen::Features::SilhouetteFlangeBuilder::ReferenceDirectionOption ( )

Returns the reference direction option
Created in NX6.0.0.



License requirements : None

NXOpen::ScCollector* NXOpen::Features::SilhouetteFlangeBuilder::ReferenceFaces ( )

Returns the reference faces.

If any reference face is selected for NXOpen::Features::SilhouetteFlangeBuilder::ReferenceDirectionOptionsFaceNormal case, the normal of reference face is used as the reference direction. Otherwise, the normal of base faces will be used as the reference direction.
Created in NX6.0.0.

License requirements : None

NXOpen::Direction* NXOpen::Features::SilhouetteFlangeBuilder::ReferenceVector ( )

Returns the reference vector
Created in NX6.0.0.



License requirements : None

void NXOpen::Features::SilhouetteFlangeBuilder::SetBaseFactor ( int  baseFactor)

Sets the base pipe continuity factor.

It's used to determine what percentage of the arc will be trimmed away in order to build the transition surface between the base faces and the pipe.
Created in NX6.0.0.

License requirements : nx_freeform_2 ("advanced freeform modeling")

Parameters
baseFactorbasefactor
void NXOpen::Features::SilhouetteFlangeBuilder::SetCreateCurves ( bool  createCurves)

Sets a value that indicates whether to create curves.

When this option is true, the center line curve of the pipe and silhouette flange curve at zero degrees will be output.
Created in NX6.0.0.

License requirements : nx_freeform_2 ("advanced freeform modeling")

Parameters
createCurvescreatecurves
void NXOpen::Features::SilhouetteFlangeBuilder::SetExtendFlange ( bool  extendFlange)

Sets a value that indicates whether to extend flange until the boundary edges of the base faces.

This option will be enforced if Trim Base Faces option is true. The base faces cannot be trimmed if the pipe does not hit the boundary edges of base faces.
Created in NX6.0.0.

License requirements : nx_freeform_2 ("advanced freeform modeling")

Parameters
extendFlangeextendflange
void NXOpen::Features::SilhouetteFlangeBuilder::SetFlangeFactor ( int  flangeFactor)

Sets the flange pipe continuity factor.

It's used to determine what percentage of the arc will be trimmed away in order to build the transition surface between the pipe and flange surface.
Created in NX6.0.0.

License requirements : nx_freeform_2 ("advanced freeform modeling")

Parameters
flangeFactorflangefactor
void NXOpen::Features::SilhouetteFlangeBuilder::SetIsDirectionFlipped ( bool  flipDirection)

Sets a flag indicating if the direction is flipped.


Created in NX6.0.0.

License requirements : nx_freeform_2 ("advanced freeform modeling")

Parameters
flipDirectionflipdirection
void NXOpen::Features::SilhouetteFlangeBuilder::SetIsSideFlipped ( bool  flipSide)

Sets a value indicating whether to flip the side.

If the side is flipped, the pipe is placed to the other side of base curves for Basic Type and the other side of the pipe of the parent feature for Absolute/Visual Gap Type.
Created in NX6.0.0.

License requirements : nx_freeform_2 ("advanced freeform modeling")

Parameters
flipSideflipside
void NXOpen::Features::SilhouetteFlangeBuilder::SetMergeFacesIfPossible ( bool  mergeFacesIfPossible)

Sets a value that indicates whether to the merge faces if possible
Created in NX6.0.0.



License requirements : nx_freeform_2 ("advanced freeform modeling")

Parameters
mergeFacesIfPossiblemergefacesifpossible
void NXOpen::Features::SilhouetteFlangeBuilder::SetOutputSurfaceOption ( NXOpen::Features::SilhouetteFlangeBuilder::OutputSurfaceOptions  outputSurfaceOption)

Sets the output surface option
Created in NX6.0.0.



License requirements : nx_freeform_2 ("advanced freeform modeling")

Parameters
outputSurfaceOptionoutputsurfaceoption
void NXOpen::Features::SilhouetteFlangeBuilder::SetPositionTolerance ( double  positionTolerance)

Sets the position tolerance
Created in NX6.0.0.



License requirements : nx_freeform_2 ("advanced freeform modeling")

Parameters
positionTolerancepositiontolerance
void NXOpen::Features::SilhouetteFlangeBuilder::SetReferenceDirectionOption ( NXOpen::Features::SilhouetteFlangeBuilder::ReferenceDirectionOptions  referenceDirectionOption)

Sets the reference direction option
Created in NX6.0.0.



License requirements : nx_freeform_2 ("advanced freeform modeling")

Parameters
referenceDirectionOptionreferencedirectionoption
void NXOpen::Features::SilhouetteFlangeBuilder::SetReferenceVector ( NXOpen::Direction referenceVctor)

Sets the reference vector
Created in NX6.0.0.



License requirements : nx_freeform_2 ("advanced freeform modeling")

Parameters
referenceVctorreferencevctor
void NXOpen::Features::SilhouetteFlangeBuilder::SetShowPipe ( bool  showPipe)

Sets a value that indicates whether to show pipe
Created in NX6.0.0.



License requirements : nx_freeform_2 ("advanced freeform modeling")

Parameters
showPipeshowpipe
void NXOpen::Features::SilhouetteFlangeBuilder::SetTangentTolerance ( double  tangentTolerance)

Sets the tangent tolerance
Created in NX6.0.0.



License requirements : nx_freeform_2 ("advanced freeform modeling")

Parameters
tangentTolerancetangenttolerance
void NXOpen::Features::SilhouetteFlangeBuilder::SetTrimBaseFaces ( bool  trimBaseFaces)

Sets a value that indicates whether to trim base faces
Created in NX6.0.0.



License requirements : nx_freeform_2 ("advanced freeform modeling")

Parameters
trimBaseFacestrimbasefaces
void NXOpen::Features::SilhouetteFlangeBuilder::SetType ( NXOpen::Features::SilhouetteFlangeBuilder::Types  type)

Sets the type
Created in NX6.0.0.



License requirements : nx_freeform_2 ("advanced freeform modeling")

Parameters
typetype
bool NXOpen::Features::SilhouetteFlangeBuilder::ShowPipe ( )

Returns a value that indicates whether to show pipe
Created in NX6.0.0.



License requirements : None

double NXOpen::Features::SilhouetteFlangeBuilder::TangentTolerance ( )

Returns the tangent tolerance
Created in NX6.0.0.



License requirements : None

bool NXOpen::Features::SilhouetteFlangeBuilder::TrimBaseFaces ( )

Returns a value that indicates whether to trim base faces
Created in NX6.0.0.



License requirements : None

NXOpen::Features::SilhouetteFlangeBuilder::Types NXOpen::Features::SilhouetteFlangeBuilder::Type ( )

Returns the type
Created in NX6.0.0.



License requirements : None

void NXOpen::Features::SilhouetteFlangeBuilder::UpdateLawSpine ( )

Update the spine curve in length/angle/radius laws.

All laws use the center line curve of the pipe as the spine curve. This API should be called if the pipe should be reconstructed due to any input change.
Created in NX6.0.0.

License requirements : nx_freeform_2 ("advanced freeform modeling")


The documentation for this class was generated from the following file:
Copyright 2017 Siemens Product Lifecycle Management Software Inc. All Rights Reserved.